package org.example.base;

import com.google.common.collect.ContiguousSet;
import com.google.common.collect.DiscreteDomain;
import com.google.common.collect.Range;

/**
 * 自定义离散域 DiscreteDomain
 * Range
 */

public class LowerCaseDomain extends DiscreteDomain<Character> {
    private static LowerCaseDomain domain = new LowerCaseDomain();

    public static DiscreteDomain letters() {
        return domain;
    }

    @Override
    public Character next(Character value) {
        return (char) (value + 1);
    }

    @Override
    public Character previous(Character value) {
        return (char) (value - 1);
    }

    @Override
    public long distance(Character start, Character end) {
        return end - start;
    }

    @Override
    public Character minValue() {
        return 'a';
    }

    @Override
    public Character maxValue() {
        return 'z';
    }

    public static void main(String[] args) {
        // a b c d e f g h i j k l m n o p q r s t u v w x y z
        for (Object i : ContiguousSet.create(Range.closed('a', 'z'), LowerCaseDomain.letters())) {
            System.out.print(i + " ");
        }

        System.out.println();

// m n o p q r s t u v w x y z
        for(Object i : ContiguousSet.create(Range.atLeast('m'), LowerCaseDomain.letters())) {
            System.out.print(i + " ");
        }
    }
}