package org.example.base;

import com.google.common.base.Optional;

// 使用和避免null： 创建Optional实例

public class OptionalGuava {
    public static void main(String[] args) {
        Optional<String> str=  Optional.of("5") ;
        // T get() 返回Optional所包含的引用，若引用缺失，则抛出java.lang.IllegalStateException
        // T or(T) 返回Optional所包含的引用，若引用缺失，返回指定的值
        if(str.isPresent())
            System.out.println(str.get() + " " + str.or("31"));
//        5 5


        Optional<String> str2=  Optional.fromNullable(null);
        if(!str2.isPresent())
            System.out.println(str2.or("22"));
//        22

        Optional<Object> p = Optional.fromNullable(null) ;
        System.out.println(p.isPresent());
        System.out.println(p.or(4));
        // 返回Optional所包含的引用，若引用缺失，返回null
        System.out.println(p.orNull());
        // 返回Optional所包含引用的单例不可变集。<br>如果引用存在，返回一个只有单一元素的集合，如果引用缺失，返回一个空集合。
        System.out.println(p.asSet());
        System.out.println(p.toString());
        System.out.println(p.get());
    }
}