package org.example.base;

import com.google.common.base.Preconditions;

import java.util.Arrays;

// 前置条件

public class PreconditionsGuava {
    private String label;

    private int[] values = new int[5];

    private int currentIndex;

    public PreconditionsGuava(String label) {
        this.label = Preconditions.checkNotNull(label, "Label can't not be null");
    }

    public void updateCurrentIndexValue(int index, int valueToSet) {
        // check index valid first
        this.currentIndex = Preconditions.checkElementIndex(index, values.length, "Index out of bounds for values.");
        // validate valueToSet
        Preconditions.checkArgument(valueToSet <= 100, "Value can't be more than 100");
        values[this.currentIndex] = valueToSet;
    }

    public void doOperation() {
        Preconditions.checkState(validateObjectState(), "Can't perform operation.");
    }

    private boolean validateObjectState() {
        return this.label.equalsIgnoreCase("open") && values[this.currentIndex] == 10;
    }

    public static void main(String[] args) {
        PreconditionsGuava demo = new PreconditionsGuava("open");

        demo.updateCurrentIndexValue(4, 10);

        demo.doOperation();

        System.out.println(demo.label);

        System.out.println(Arrays.toString(demo.values));

        System.out.println(demo.validateObjectState());

        PreconditionsGuava demo1 = new PreconditionsGuava(null);

        demo1.updateCurrentIndexValue(1, 1);

        demo1.doOperation();

    }
}
