package org.example.base;

import com.google.common.collect.ContiguousSet;
import com.google.common.collect.DiscreteDomain;
import com.google.common.collect.Lists;
import com.google.common.collect.Range;
import org.junit.Test;

import java.util.Set;

/**
 * 离散域 DiscreteDomain
 * Range
 */

public class RangeGuava {
        @Test
        public void test6() {
                Range<Integer> range = Range.closed(20, 30);
                print("closed", ContiguousSet.create(range, DiscreteDomain.integers()));

                range = Range.open(20, 30);
                print("open", ContiguousSet.create(range, DiscreteDomain.integers()));

                range = Range.openClosed(20, 30);
                print("openClosed", ContiguousSet.create(range, DiscreteDomain.integers()));

                range = Range.closedOpen(20, 30);
                print("closedOpen", ContiguousSet.create(range, DiscreteDomain.integers()));

                range = Range.greaterThan(20);
                System.out.println("greaterThan: " + ContiguousSet.create(range, DiscreteDomain.integers()).toString());

                range = Range.atLeast(20);
                System.out.println("atLeast: " + ContiguousSet.create(range, DiscreteDomain.integers()).toString());

                range = Range.lessThan(30);
                System.out.println("lessThan: " + ContiguousSet.create(range, DiscreteDomain.integers()).toString());

                range = Range.atMost(30);
                System.out.println("atMost: " + ContiguousSet.create(range, DiscreteDomain.integers()).toString());

                range = Range.all();
                System.out.println("all: " + ContiguousSet.create(range, DiscreteDomain.integers()).toString());
        }

        public static void print(String type, Set<Integer> ranges) {
                System.out.println(type + "：" + ranges + "      list：" + Lists.newArrayList(ranges));
        }
}