package org.example.reflection;

import com.google.common.reflect.Reflection;

import java.lang.reflect.Field;

public class GuavaReflectionExample {
    private int myField;

    public static void main(String[] args) throws NoSuchFieldException, IllegalAccessException {
        GuavaReflectionExample example = new GuavaReflectionExample();
        Field field = GuavaReflectionExample.class.getDeclaredField("myField");

        Reflection.initialize(example.getClass());

        // Make the field accessible if it's private or protected
        field.setAccessible(true);

        // Set the field value
        field.set(example, 42);

        System.out.println(example.myField); // prints 42

        System.out.println(Reflection.getPackageName(GuavaReflectionExample.class));
    }
}